const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const estrutura_projeto = sequelize.define(
    'estrutura_projeto',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      etapa: {
        type: DataTypes.TEXT,
      },

      atividade: {
        type: DataTypes.TEXT,
      },

      descricao: {
        type: DataTypes.TEXT,
      },

      prazo_estimado_dias: {
        type: DataTypes.INTEGER,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  estrutura_projeto.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.estrutura_projeto.hasMany(db.historico_alteracoes_projeto, {
      as: 'historico_alteracoes_projeto_estrutura',
      foreignKey: {
        name: 'estruturaId',
      },
      constraints: false,
    });

    db.estrutura_projeto.hasMany(db.maquinas_atividade, {
      as: 'maquinas_atividade_estrutura',
      foreignKey: {
        name: 'estruturaId',
      },
      constraints: false,
    });

    db.estrutura_projeto.hasMany(db.materiais_atividade, {
      as: 'materiais_atividade_estrutura',
      foreignKey: {
        name: 'estruturaId',
      },
      constraints: false,
    });

    db.estrutura_projeto.hasMany(db.pessoas_atividade, {
      as: 'pessoas_atividade_estrutura',
      foreignKey: {
        name: 'estruturaId',
      },
      constraints: false,
    });

    //end loop

    db.estrutura_projeto.belongsTo(db.obras, {
      as: 'obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.estrutura_projeto.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.estrutura_projeto.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.estrutura_projeto.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return estrutura_projeto;
};
